/* @Packager.Header
<FileDescription>
	FCKXml Class: class to load and manipulate XML files.
</FileDescription>
<Author name="Frederico Caldeira Knabben" email="www.fckeditor.net" />
*/

var FCKXml = function()
{}

FCKXml.prototype.LoadUrl = function( urlToCall )
{
	this.Error = false ;
	var oFCKXml = this ;

	var oXmlHttp = FCKTools.CreateXmlObject( 'XmlHttp' ) ;
	oXmlHttp.open( "GET", urlToCall, false ) ;
	oXmlHttp.send( null ) ;
	
	if ( oXmlHttp.status == 200 || oXmlHttp.status == 304 )
		this.DOMDocument = oXmlHttp.responseXML ;
	else if ( oXmlHttp.status == 0 && oXmlHttp.readyState == 4 )
		this.DOMDocument = oXmlHttp.responseXML ;
	else
		this.DOMDocument = null ;

	if ( this.DOMDocument == null || this.DOMDocument.firstChild == null )
	{
		this.Error = true ;
		if (window.confirm( 'Error loading "' + urlToCall + '"\r\nDo you want to see more info?' ) )
			alert( 'URL requested: "' + urlToCall + '"\r\n' +
						'Server response:\r\nStatus: ' + oXmlHttp.status + '\r\n' +
						'Response text:\r\n' + oXmlHttp.responseText ) ;

	}
}

FCKXml.prototype.SelectNodes = function( xpath, contextNode )
{
	if ( this.Error )
		return new Array() ;

	var aNodeArray = new Array();

	var xPathResult = this.DOMDocument.evaluate( xpath, contextNode ? contextNode : this.DOMDocument, 
			this.DOMDocument.createNSResolver(this.DOMDocument.documentElement), XPathResult.ORDERED_NODE_ITERATOR_TYPE, null) ;
	if ( xPathResult ) 
	{
		var oNode = xPathResult.iterateNext() ;
		while( oNode )
		{
			aNodeArray[aNodeArray.length] = oNode ;
			oNode = xPathResult.iterateNext();
		}
	} 
	return aNodeArray ;
}

FCKXml.prototype.SelectSingleNode = function( xpath, contextNode ) 
{
	if ( this.Error )
		return null ;

	var xPathResult = this.DOMDocument.evaluate( xpath, contextNode ? contextNode : this.DOMDocument,
			this.DOMDocument.createNSResolver(this.DOMDocument.documentElement), 9, null);

	if ( xPathResult && xPathResult.singleNodeValue )
		return xPathResult.singleNodeValue ;
	else	
		return null ;
}